///////////////////////////////////////////////////////////////////
//3D Studie zu Lissajous-Kurven
//Taste 'k' umschalten nur Kurve/ Kurve mit Verbindung zum Ursprung
//Taste 'l' umschalten Lissajous/beliebige trigonom. Kurve
//Tasten '1'...'9' Frequenzen und Amplituden vergrößern
//Taste 'a' Anzahl Punkte halbieren - Taste 'b' Anzahl Punkte verdoppeln
//Taste 'p' Winkel-Schritt halbieren - Taste 'q' Winkel-Schritt verdoppeln
//Taste 'f' Farbverlauf ändern
/////////////////////////////////////////////////////////////////
int anzPkte,reduzAnzPkte;
float alpha,delta ;//Drehung um diese Winkel um y- bzw z-Achse
int xi,yi,zi;
Point p;
float D;
int l,neuStart;
ArrayList<Point> lissajousPkte;
float winkelDelta;
float frequenz[],frequenzMod[],amplitude[];
float winkelGrad;
float winkelBogenM = 0;
float gesamtWinkel = 360;
int abschnitte =64;
int grenze = abschnitte+1;
int f =0; //Farbnummer für die Fläche
int F =0; //Farbnummer für den Pfad
color[] farbAnker; 
color[] farben4096;
color farbe; 
float h1,b1;
float h2,b2;
float S1, S2;
boolean lissajous = true;
boolean wegLassen;
boolean nurKurve;
boolean pfadRot = true;

void setup() {
  size(800, 800,P3D); 
  colorMode(HSB,256,256,256);
  farbVerlaufErzeugen();
  winkelDelta = 0.05;
  anzPkte = round(gesamtWinkel/winkelDelta);
  nurKurve =false;
  alpha  = 0;delta  =0;
  frequenz = new float[3];
  frequenzMod = new float[3];
  amplitude = new float[3]; 
  frequenz[0] = 3;
  frequenz[1] = 6;
  frequenz[2] = 7;
  frequenzMod[0] = 7;
  frequenzMod[1] = 13;
  frequenzMod[2] = 11;
  
  println("Frequenz 1:= "+frequenz[0]);  
  println("Frequenz 2:= "+frequenz[1]); 
  println("Frequenz 3:= "+frequenz[2]);  
  amplitude[0] = width/4;
  amplitude[1] = width/4+80;
  amplitude[2] = width/4-80;
  winkelGrad=0;  
  lissajousPunkteBerechnen();  
}

public void draw() {
  smooth();
  if(nurKurve)background(255);
  else background(0);
  //directionalLight(0,0,255,0,0,-1);
 // lights();//ausgeschaltet keine Struktur
  translate(width/2, height/2, 0);
  pushMatrix();
    rotateY(delta);
    pushMatrix();
      rotateZ(alpha);
      neuStart = 1;     
      while(neuStart<reduzAnzPkte-2){
        lissajousPfadZeichnen(neuStart); 
      } 
      if(!nurKurve){
        neuStart = 1;     
        while(neuStart<reduzAnzPkte-2){
          lissajous3DZeichnen(neuStart);
        } 
      }
      f=0;
    popMatrix();
  popMatrix();
  alpha   += 0.004;
  delta   += 0.004;
  //noLoop();
}
/////////////////////////////////////////////////////////////////////
void lissajousPunkteBerechnen() {
  
   lissajousPkte = new ArrayList<Point>();
   wegLassen =false;
   for(int k =0; k<=anzPkte-1;k++){
     winkelBogenM = radians(winkelGrad);
     if(lissajous){
       xi=round(amplitude[0]*sin(frequenz[0]*winkelBogenM));
       yi=round(amplitude[1]*sin(frequenz[1]*winkelBogenM));
       zi=round(amplitude[2]*sin(frequenz[2]*winkelBogenM));
     }else{
       xi = round(amplitude[0]*sin(frequenz[0]*winkelBogenM) + amplitude[0]/8*cos(frequenzMod[0]*winkelBogenM));
       yi = round(amplitude[1]*sin(frequenz[1]*winkelBogenM) + amplitude[1]/8*cos(frequenzMod[1]*winkelBogenM));
       zi = round(amplitude[2]*sin(frequenz[2]*winkelBogenM) + amplitude[2]/8*cos(frequenzMod[2]*winkelBogenM));
     }
     
     p = new Point(xi,yi,zi);
     for(Point q: lissajousPkte){
       if(q.abstandVon(p)<4) wegLassen = true;//so vermeidet man kleine Farbinseln
     }
     if(!wegLassen)  lissajousPkte.add(p);  
       winkelGrad =winkelGrad+winkelDelta;  
       wegLassen = false;
     }
     reduzAnzPkte = lissajousPkte.size();// println(reduzAnzPkte);
}
//////////////////////////////////////////////////////////////////////////////
void lissajousPfadZeichnen(int von){
   strokeWeight(10);  
   noFill();
   neuStart =von;
   l=von;
   F=0;
   beginShape();  
     while (l<=reduzAnzPkte-2){
      
       if(F==4096)F=0;
       D = lissajousPkte.get(l-1).abstandVon(lissajousPkte.get(l));
       if(D< 15 ){//nächsterPunkt näher als D 
          if(pfadRot) stroke(0,255,255);
          else stroke(farben4096[F],255);  
          
         //curveVertex(lissajousPkte.get(l).x, lissajousPkte.get(l).y, lissajousPkte.get(l).z);
         line(lissajousPkte.get(l).x, lissajousPkte.get(l).y, lissajousPkte.get(l).z,lissajousPkte.get(l+1).x,
             lissajousPkte.get(l+1).y, lissajousPkte.get(l+1).z);
         point(lissajousPkte.get(l).x, lissajousPkte.get(l).y, lissajousPkte.get(l).z);//so weniger Lücken
       }else{//nächster Punkt weiter als D entfernt - würde zu falschen Verbindungen führen
         if(l>=reduzAnzPkte) neuStart = reduzAnzPkte;
         else neuStart= l+1;//starte bei nächstem Punkt neu!
         break;
       }
       l++;
       F++;
       if(l==reduzAnzPkte-1)neuStart=reduzAnzPkte;//beendet die while-Schleife lissajousPfadZeichnen(neuStart)
     }
   endShape();  
}
////////////////////////////////////////////////////////////////////////////
void lissajous3DZeichnen(int von){  
   noStroke();
   strokeWeight(8);  
   neuStart =von;
   l=von;
   F=0;
   beginShape(TRIANGLE_FAN);  
      while (l<=reduzAnzPkte-2){
       if(F==4096)F=0;
       D = lissajousPkte.get(l-1).abstandVon(lissajousPkte.get(l));
       if(D< 15 ){//nächsterPunkt näher als D 
         fill(farben4096[F],255);
         vertex(0, 0, 0);
         vertex(lissajousPkte.get(l).x, lissajousPkte.get(l).y, lissajousPkte.get(l).z);    
         vertex(lissajousPkte.get(l+1).x, lissajousPkte.get(l+1).y, lissajousPkte.get(l+1).z);  
        
       }else{//nächster Punkt weiter als D entfernt - würde zu falschen Verbindungen führen
         if(l>=reduzAnzPkte) neuStart = reduzAnzPkte;
         else neuStart= l+1;//starte bei nächstem Punkt neu!
         break;
       }
       l++;
       F++;
       if(l==reduzAnzPkte-1)neuStart=reduzAnzPkte;//beendet die while-Schleife  lissajous3DZeichnen(neuStart)
     }
   endShape();  
}
////////////////////////////////////////////////////////////////////////
void farbVerlaufErzeugen(){
  farbAnker = new color[grenze];//Initialsierung
  for(int i=0;i<grenze;i++){
     farbAnker[i] = color(0);
  }
 
  farben4096 = new color[4096];
  for(int i=0;i<4096;i++){
     farben4096[i] = color(0);
  }
  h1=random(256);
  b1=random(100,256);
  farbAnker[0] = color(h1,255,b1); 
  for(int j=1; j<grenze; j++){
      farbAnker[j] = farbeBestimmen( farbAnker[j-1]);  
  }
  for(int i=0; i<abschnitte; i++){
    zwischenFarbenBestimmen(i*abschnitte,farbAnker[i],farbAnker[i+1]);
  }
  winkelGrad=0;
}

/////////////////////////////////////////////////////////////////////////
color farbeBestimmen(color f){
  color farbe = color(0);//Initialisierung
  h1=hue(f);
  b1=brightness(f);
  h2=random(256);
  b2=255;//b2=random(100,256);//Variante
  S1 =abs(h2-h1); 
  S2 =abs(b2-b1);
  while(S1>50 || S1<20){//Steurung der "Abstände" der Ankerfarben
     h2=random(256);
     b2=255;//b2=random(100,256);//Variante
     S1 =abs(h2-h1); 
     S2 =abs(b2-b1);  
  }
  farbe = color(h2,255,b2);
  return farbe;
}
////////////////////////////////////////////////////////////////////
void zwischenFarbenBestimmen(int k, color f1, color f2){
   int start = k;
   for(int i=start; i<64+start;i++){
      farben4096[i] = lerpColor(f1,f2,(float)(i-start)/64);
   }
}
/////////////////////////////////////////////////////////////////
void keyPressed() {
   
   if (key ==  '1'){   
      frequenz[0]++;
      lissajousPunkteBerechnen();     
   }
   if (key ==  '2'){   
      frequenz[1]++;
      lissajousPunkteBerechnen();      
   }
    if (key ==  '3'){   
      frequenz[2]++;
      lissajousPunkteBerechnen();
   }
    if (key ==  '4'){   
      frequenzMod[0]++;
      lissajousPunkteBerechnen();     
   }
   if (key ==  '5'){   
      frequenzMod[1]++;
      lissajousPunkteBerechnen();      
   }
    if (key ==  '6'){   
      frequenzMod[2]++;
      lissajousPunkteBerechnen();
   }
   if (key ==  '7'){  
      amplitude[0]=amplitude[0]+20;      
      lissajousPunkteBerechnen();     
   }
   if (key ==  '8'){   
      amplitude[1]=amplitude[1]+20;
      lissajousPunkteBerechnen();      
   }
    if (key ==  '9'){   
      amplitude[2]=amplitude[2]+20;
      lissajousPunkteBerechnen();
   }   
   if (key == 'a'){   
      anzPkte = round(anzPkte/2);
      lissajousPunkteBerechnen();     
   }   
   if (key == 'b'){   
      anzPkte = 2*anzPkte;
      lissajousPunkteBerechnen();
   } 
   if (key == 'p'){
      winkelDelta=winkelDelta*0.5;
      lissajousPunkteBerechnen();
   }
   if (key == 'q'){
      winkelDelta=winkelDelta*2;
      lissajousPunkteBerechnen();
   }
   if (key == 'k'){
      nurKurve=!nurKurve;
      lissajousPunkteBerechnen();
   }
   if (key == 'f'){
      farbVerlaufErzeugen();
   }
   if (key == 's'){
      pfadRot=!pfadRot;
      lissajousPunkteBerechnen();
   }
   if (key == 'l'){
      lissajous = !lissajous;
      lissajousPunkteBerechnen();     
      if(lissajous)println("Ränder sind Lissajous-Kurven");
      else println("Ränder werden durch beliebige Trigonometrische Kurven erzeugt");
   }
     
    println("Frequenz 1:= "+frequenz[0]);  
    println("Frequenz 2:= "+frequenz[1]); 
    println("Frequenz 3:= "+frequenz[2]);  
    println();
    println("Anzahl Punkte: "+anzPkte);
    println();
    println("Winkel-Delta: "+winkelDelta);
    if(!lissajous){
      println("FrequenzMod 1:= "+frequenzMod[0]);  
      println("FrequenzMod 2:= "+frequenzMod[1]); 
      println("FrequenzMod 3:= "+frequenzMod[2]);  
      println("AmplitudenMod 1:= "+amplitude[0]);  
      println("AmplitudenMod 1:= "+amplitude[1]);  
      println("AmplitudenMod 2:= "+amplitude[2]);  
      println();
      println("Anzahl Punkte: "+anzPkte);
      println();
      println("Winkel-Delta: "+winkelDelta);
    }
}


class Point{
 
  int x;
  int y;
  int z;
 
  Point (int x, int y, int z) {
 
    this.x = x;
    this.y = y;
    this.z = z;
  }
 
  boolean equals(Point point){
  
    return this.x == point.x && this.y == point.y&& this.z == point.z;
  }
  
  float abstandVon(Point point){
    float d =0;
    d=sqrt((this.x-point.x)*(this.x-point.x)+(this.y-point.y)*(this.y-point.y)+(this.z-point.z)*(this.z-point.z));
    return d;
  }
 
 
}
